clear all
 ...
global scalv_ ex_ ex_det_ recur_ recurs_ ys_ y_ exe_ exe_det_ lgy_ lgx_ lgx_det_ lgr_ dsmpl_ endval_
 ...
global endo_nbr exo_nbr exo_det_nbr iy_  ykmin_  ykmax_  xkmin_  xkmax_ zkmin_ zkmax_ iter_
 ...
global dynatol_ slowc_ maxit_ valf_ ys0_ recurs0_ ex0_ timing_ ct_ gstep_ Sigma_e_ fname_ lgx_orig_ord_ iter_ options_ dr_ oo_ trend_coeff_ eigenvalues_
global M_
M_.ex_det_length = 0;
M_.dname = 'DSGE1C';
endo_nbr=0;exo_nbr=0;exo_det_nbr=0;
dsmpl_=0;
dynatol_=0.00001;
maxit_=10;
slowc_=1;
timing_=0;
ct_=0;
gstep_=1e-2;
endval_=0;rplottype_=0;
valf_=0;
y_=[];
ex_=[];
ex_det_=[];
fname_ = 'DSGE1C';
logname_ = 'DSGE1C.log';
diary off;
warning off;
delete DSGE1C.log;
warning on;
warning backtrace;
diary DSGE1C.log;
options_ = [];
%DSGE model pro odhad potencialniho produktu
clc;
close all;

%definice promennych
%endogenni
lgy_ = 'a';
lgy_ = str2mat(lgy_,'d');
lgy_ = str2mat(lgy_,'gap');
lgy_ = str2mat(lgy_,'n');
lgy_ = str2mat(lgy_,'phi');
lgy_ = str2mat(lgy_,'pi');
lgy_ = str2mat(lgy_,'pi_poz');
lgy_ = str2mat(lgy_,'r');
lgy_ = str2mat(lgy_,'r_poz');
lgy_ = str2mat(lgy_,'u');
lgy_ = str2mat(lgy_,'u_f');
lgy_ = str2mat(lgy_,'y');
lgy_ = str2mat(lgy_,'y_f');
lgy_ = str2mat(lgy_,'y_poz');
lgy_ = str2mat(lgy_,'z');
endo_nbr = 15;


%exogenni
lgx_ = 'epsilon_a';
lgx_ = str2mat(lgx_,'epsilon_d');
lgx_ = str2mat(lgx_,'epsilon_r');
lgx_ = str2mat(lgx_,'epsilon_z');
lgx_orig_ord_ = [4 2 1 3];
exo_nbr = 4;


%parametry

global beta eta gamma_ss h omega pi_ss psi_pi psi_y r_ss rho_a 
global rho_d rho_r rho_z tau 


%kalibrace modelu - nastaveni hodnot paramteru
tau = 1.5;
beta = 0.99;
h = 0.8;
omega = 0.6;
eta = 1.5;
psi_y = 0.3;
psi_pi = 1.5;
rho_r = 0.65;
rho_d = 0.5;
rho_z = 0.5;
rho_a = 0.7;
gamma_ss = 0.5;
pi_ss = 3.5;
r_ss = 1.8;


%modelove rovnice - rovnice jiz log-linearizovane - upresnime volbou linear + pridame rovnice pro pozorovane veliciny
options_.linear=1;
iy_ = [ 1 2 0 0 0 0 0 3 0 0 0 4 5 0 6];
temp = [ 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21];
iy_ = [ iy_ ; temp ];
temp = [ 0 22 0 0 0 23 0 0 0 24 0 25 26 0 27];
iy_ = [ iy_ ; temp ];
ykmin_ = 1;
ykmax_ = 1;
xkmin_ = 0;
xkmax_ = 0;
zkmin_ = 0;
zkmax_ = 0;
ys_ = zeros(15,1);
exe_ = zeros(4,1);


%nastaveni pocatecnich podminek pro vypocet steady statu - model je gapovy, steady state je tedy pro vsechny promenne 0
% INITVAL 
valf_ = 0;
endval_=0;
ys_(12)=0;
ys_(8)=0;
ys_(6)=0;
ys_(2)=0;
ys_(4)=0;
ys_(15)=0;
ys_(13)=0;
ys_(1)=0;
y_=[ys_*ones(1,ykmin_)];
if exo_nbr > 0;
  ex_=[ones(xkmin_,1)*exe_'];
end;
if exo_det_nbr > 0;
  ex_det_=[ones(ykmin_+1,1)*exe_det_'];
end;

%u, u_f, phi, y_poz, pi_poz, r_poz, gap si sam dopocita

%specifikace soku
sigma_r = 0.3;%sigma_r - smerodatna odchylka pro monetarni sok
sigma_d = 0.5;%sigma_d - smerodatna odchylka pro poptavkovy sok
sigma_z = 0.5;%sigma_z - smerodatna odchylka pro nabidkovy sok
sigma_a = 0.8;%sigma_a - smerodatna odchylka pro technologicky sok

% (M)SHOCKS 
make_ex_;
shocks_file(0);
Sigma_e_ = zeros(4,4);
Sigma_e_(3,3) = (sigma_r)^2;
Sigma_e_(2,2) = (sigma_d)^2;
Sigma_e_(4,4) = (sigma_z)^2;
Sigma_e_(1,1) = (sigma_a)^2;


%vypocet steady statu
% vystup - lgy_ - abecedne serazene promenne, ys_ hodnoty steady statu
steady(0);


%jedina stabilni rovnovah v okoli steady statu - pocet vlastnich cisel modelu musi byt stejny jako pocet promenych v ocekavanich
%vystup - eigenvalues_ - hodnoty vlastnich cisel
check;


%odhadovane parametry a jejich priory
global estim_params_
estim_params_.var_exo = [];
estim_params_.var_endo = [];
estim_params_.corrx = [];
estim_params_.corrn = [];
estim_params_.param_names = [];
estim_params_.param_vals = [];
estim_params_.param_names = strvcat(estim_params_.param_names,'tau');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 1.1, 0.5, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'h');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 1 ...
, 0.8, 0.1, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'eta');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 1.5, 0.3, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'omega');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 1 ...
, 0.6, 0.2, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'psi_pi');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 1.5, 0.3, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'psi_y');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 0.3, 0.15, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'rho_r');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 1 ...
, 0.65, 0.25, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'rho_d');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 1 ...
, 0.5, 0.25, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'rho_z');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 1 ...
, 0.5, 0.25, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'rho_a');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 1 ...
, 0.7, 0.25, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'gamma_ss');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 0.5, 0.3, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'pi_ss');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 3.5, 0.5, NaN, NaN, NaN];
estim_params_.param_names = strvcat(estim_params_.param_names,'r_ss');
estim_params_.param_vals = [estim_params_.param_vals; NaN, -Inf, Inf, 2 ...
, 1.8, 0.3, NaN, NaN, NaN];
estim_params_.var_exo = [estim_params_.var_exo;  3, NaN, -Inf, Inf, 4, 0.3 ...
, inf, NaN, NaN, NaN];
estim_params_.var_exo = [estim_params_.var_exo;  2, NaN, -Inf, Inf, 4, 0.5 ...
, inf, NaN, NaN, NaN];
estim_params_.var_exo = [estim_params_.var_exo;  4, NaN, -Inf, Inf, 4, 0.5 ...
, inf, NaN, NaN, NaN];
estim_params_.var_exo = [estim_params_.var_exo;  1, NaN, -Inf, Inf, 4, 0.8 ...
, inf, NaN, NaN, NaN];


%upresneni pozorovanych velicin
options_.varobs = [];
options_.varobs = strvcat(options_.varobs,'y_poz');
options_.varobs = strvcat(options_.varobs,'pi_poz');
options_.varobs = strvcat(options_.varobs,'r_poz');


%vytvorim si vektory pro TeXove soubory
global lgx_TeX_ lgy_TeX_ ;
lgx_TeX_ = '\epsilon_a';
lgx_TeX_ = strvcat(lgx_TeX_,'\epsilon_d');
lgx_TeX_ = strvcat(lgx_TeX_,'\epsilon_r');
lgx_TeX_ = strvcat(lgx_TeX_,'\epsilon_z');

lgy_TeX_ = 'a';
lgy_TeX_ = strvcat(lgy_TeX_,'d');
lgy_TeX_ = strvcat(lgy_TeX_,'gap');
lgy_TeX_ = strvcat(lgy_TeX_,'n');
lgy_TeX_ = strvcat(lgy_TeX_,'\phi');
lgy_TeX_ = strvcat(lgy_TeX_,'\pi');
lgy_TeX_ = strvcat(lgy_TeX_,'\pi_{poz}');
lgy_TeX_ = strvcat(lgy_TeX_,'r');
lgy_TeX_ = strvcat(lgy_TeX_,'r_{poz}');
lgy_TeX_ = strvcat(lgy_TeX_,'u');
lgy_TeX_ = strvcat(lgy_TeX_,'u^f');
lgy_TeX_ = strvcat(lgy_TeX_,'y');
lgy_TeX_ = strvcat(lgy_TeX_,'y^f');
lgy_TeX_ = strvcat(lgy_TeX_,'y_{poz}');
lgy_TeX_ = strvcat(lgy_TeX_,'z');

estim_params_.tex = '\tau';
estim_params_.tex = strvcat(estim_params_.tex,'h');
estim_params_.tex = strvcat(estim_params_.tex,'\eta');
estim_params_.tex = strvcat(estim_params_.tex,'\omega');
estim_params_.tex = strvcat(estim_params_.tex,'\psi_{\pi}');
estim_params_.tex = strvcat(estim_params_.tex,'\psi_y');
estim_params_.tex = strvcat(estim_params_.tex,'\rho_r');
estim_params_.tex = strvcat(estim_params_.tex,'\rho_d');
estim_params_.tex = strvcat(estim_params_.tex,'\rho_z');
estim_params_.tex = strvcat(estim_params_.tex,'\rho_a');
estim_params_.tex = strvcat(estim_params_.tex,'\gamma^{ss}');
estim_params_.tex = strvcat(estim_params_.tex,'\pi^{ss}');
estim_params_.tex = strvcat(estim_params_.tex,'r^{ss}');

options_.varobs_TeX = 'y_{poz}';
options_.varobs_TeX = strvcat(options_.varobs_TeX,'\pi_{poz}');
options_.varobs_TeX = strvcat(options_.varobs_TeX,'r_{poz}');

%odhad
%volby - conf_sig - hladina pro vypocet intervalu spolehlivosti (0.9)
%        mh_replic - pocet replikaci v M-H algoritmu (20000)
%        mh_nblocks - pocet paralelnich bloku v M-H (2)
%        mh_drop - podil vyhozenych vzorku (0.5)
%        mh_jscale - velikost skoku pri hledani v M-H - ovlivnuje velikost akceptacni pravdepodobnosti (0.2)
%        mh_init_scale (2* mh_jscale)
%        bayesian_irf - bayesianska IRF, delka dana irf
%        smoother - pomoci KF vypocita smoothovane hodnoty parametru
%        forecast - predpoved
%        tex - vyhazuje soubory pro TeX
%        mh_init_scale=0.3
%        mode_check

options_.datafile='data_source2';
options_.mh_replic=1000000;
options_.mh_jscale=0.35;
options_.smoother=1;
options_.TeX=1;
var_list_ = [];
dynare_estimation(var_list_);
save('DSGE1C_results','oo_','dr_');
diary off
