clear all
close all
clc

%1996Q1 - 2008Q4 = 1996.25 - 2009.00
t = 1996:1/4:2009;
t = t(2:end)';

%nulovy vektor
tz = 1996:1/4:2010;
n = length(tz);
z = zeros(n,1);

%zkraceni
t = t(2:end);

%nacteni vysledku odhadu
load DSGE1C_results
gap = oo_.PosteriorSmoothedVariables.Mean.gap;
gap_inf = oo_.PosteriorSmoothedVariables.HPDinf.gap;
gap_sup = oo_.PosteriorSmoothedVariables.HPDsup.gap;

yp = oo_.PosteriorSmoothedVariables.Mean.y_f;
yp_inf = oo_.PosteriorSmoothedVariables.HPDinf.y_f;
yp_sup = oo_.PosteriorSmoothedVariables.HPDsup.y_f;

y = oo_.PosteriorSmoothedVariables.Mean.y;
y_inf = oo_.PosteriorSmoothedVariables.HPDinf.y;
y_sup = oo_.PosteriorSmoothedVariables.HPDsup.y;

%Model 1 - gamma jako nahodna prochazka
load DSGE2_results
gap2 = oo_.PosteriorSmoothedVariables.Mean.gap;
gap2_inf = oo_.PosteriorSmoothedVariables.HPDinf.gap;
gap2_sup = oo_.PosteriorSmoothedVariables.HPDsup.gap;

yp2 = oo_.PosteriorSmoothedVariables.Mean.y_f;
yp2_inf = oo_.PosteriorSmoothedVariables.HPDinf.y_f;
yp2_sup = oo_.PosteriorSmoothedVariables.HPDsup.y_f;

y2 = oo_.PosteriorSmoothedVariables.Mean.y;
y2_inf = oo_.PosteriorSmoothedVariables.HPDinf.y;
y2_sup = oo_.PosteriorSmoothedVariables.HPDsup.y;

gamma_ss = oo_.PosteriorSmoothedVariables.Mean.gamma_ss;


%Model 2 - pie jako nahodna prochazka
load DSGE4_results
gap4 = oo_.PosteriorSmoothedVariables.Mean.gap;
gap4_inf = oo_.PosteriorSmoothedVariables.HPDinf.gap;
gap4_sup = oo_.PosteriorSmoothedVariables.HPDsup.gap;

yp4 = oo_.PosteriorSmoothedVariables.Mean.y_f;
yp4_inf = oo_.PosteriorSmoothedVariables.HPDinf.y_f;
yp4_sup = oo_.PosteriorSmoothedVariables.HPDsup.y_f;

y4 = oo_.PosteriorSmoothedVariables.Mean.y;
y4_inf = oo_.PosteriorSmoothedVariables.HPDinf.y;
y4_sup = oo_.PosteriorSmoothedVariables.HPDsup.y;

pi_ss = oo_.PosteriorSmoothedVariables.Mean.pi_ss;


%Model 3 - inflacni cil
load DSGE3_results
gap3 = oo_.PosteriorSmoothedVariables.Mean.gap;
gap3_inf = oo_.PosteriorSmoothedVariables.HPDinf.gap;
gap3_sup = oo_.PosteriorSmoothedVariables.HPDsup.gap;

yp3 = oo_.PosteriorSmoothedVariables.Mean.y_f;
yp3_inf = oo_.PosteriorSmoothedVariables.HPDinf.y_f;
yp3_sup = oo_.PosteriorSmoothedVariables.HPDsup.y_f;

y3 = oo_.PosteriorSmoothedVariables.Mean.y;
y3_inf = oo_.PosteriorSmoothedVariables.HPDinf.y;
y3_sup = oo_.PosteriorSmoothedVariables.HPDsup.y;

figure
plot(t, gap,'b-',t,gap_inf,'b:',t, gap_sup,'b:',tz,z,'k-');
legend('Mezera vstupu','90% interval spolehlivosti')

figure
plot(t, gap2,'b-',t,gap2_inf,'b:',t, gap2_sup,'b:',tz,z,'k-');
legend('Mezera vstupu - Model 1','90% interval spolehlivosti')

figure
plot(t, gap4,'b-',t,gap4_inf,'b:',t, gap4_sup,'b:',tz,z,'k-');
legend('Mezera vstupu - Model 2','90% interval spolehlivosti')

figure
plot(t, gap3,'b-',t,gap3_inf,'b:',t, gap3_sup,'b:',tz,z,'k-');
legend('Mezera vstupu - Model 3','90% interval spolehlivosti')


figure
plot(t, gap,'b-',t, gap2,'r-',t, gap4,'g-',t, gap3,'m-',tz,z,'k-');
legend('Zkladn odhad','Model 1','Model 2','Model 3')

%produkt
figure
plot(t, y,'b-',t, y2,'r-',t, y4,'g-',t, y3,'m-',tz,z,'k-');
legend('Zkladn odhad','Alternativn model 1','Alternativn model 2','Alternativn model 3')

%potencial
figure
plot(t, yp,'b-',t, yp2,'r-',t, yp4,'g-',t, yp3,'m-',tz,z,'k-');
legend('Zkladn odhad','Alternativn model 1','Alternativn model 2','Alternativn model 3')

%Model 1 - gamma_ss
figure
plot(t,gamma_ss+0.65,'b-',tz,z,'k-');

%Model 2 - pi_ss
figure
plot(t,pi_ss+3.5,'b-');

%Srovnn produktu
figure
subplot(2,2,1)
plot(t, y,'b-',t, yp,'r-',tz,z,'k-');
ylim([-7 7]);
xlim([1996 2010]);
title('Zkladn model')
legend('Aktuln produkt','Potenciln produkt')

subplot(2,2,2)
plot(t, y2,'b-',t, yp2,'r-',tz,z,'k-');
ylim([-2 2]);
xlim([1996 2010]);
title('Model 1')

subplot(2,2,3)
plot(t, y4,'b-',t, yp4,'r-',tz,z,'k-');
ylim([-7 7]);
xlim([1996 2010]);
title('Model 2')

subplot(2,2,4)
plot(t, y3,'b-',t, yp3,'r-',tz,z,'k-');
ylim([-7 7]);
xlim([1996 2010]);
title('Model 3')
